<template>
  <div class="backgrounded-text">
    <div
      class="backgrounded-text__bg"
      :style="{ fill: bgcolor, backgroundColor: bgcolor }"
    >
      <PolygonShape />
    </div>
    <div class="backgrounded-text__content" :style="{ color: color }">
      <slot>
        <div v-html="text" />
      </slot>
    </div>
  </div>
</template>

<script>
export default {
  props: {
    text: {
      type: String,
      default: '',
    },
    color: {
      type: String,
      default: 'black',
    },
    bgcolor: {
      type: String,
      default: 'white',
    },
  },
}
</script>

<style lang="scss" scoped>
.backgrounded-text {
  :deep(h1) {
    @apply text-2xl uppercase font-medium mb-1 text-left;
  }

  :deep(h2) {
    @apply text-xl uppercase font-medium mb-3 text-left;
  }
  :deep(h3) {
    @apply text-lg uppercase font-medium mb-2 text-left;
  }

  :deep(p) {
    @apply my-2;
  }
  :deep(img),
  :deep(iframe) {
    @apply mb-4;

    @apply max-w-lg mx-auto;
    @screen lg {
      @apply max-w-md;
    }
  }
}

.backgrounded-text {
  @apply relative flex  mt-12 p-0 py-12 w-full;
  transform: translateX(0);
  @screen md {
    @apply py-20;
    @apply self-start;
  }
  @screen xl {
    @apply max-w-xl;
    @apply pt-0  w-full mt-32 pb-16;
    @apply self-start;

    // margin-left: 5%;
  }
  @screen xxl {
    @apply self-center;
    transform: translateX(-100%);
  }

  &:nth-child(even) {
    @screen xl {
      @apply self-end;
      margin-top: -100px;
    }
    @screen xxl {
      @apply self-center;
      transform: translateX(50%);
      //   margin-left: 55%;
    }
  }
  p {
    @apply pt-4;
  }

  :deep(a) {
    @apply underline;
  }

  &__bg {
    @apply absolute inset-0 flex-grow w-full -ml-20;
    opacity: 1;

    width: 150%;
    @screen md {
      opacity: 0.9;
    }
    @screen xl {
      width: 120%;

      background: none !important;
      @apply -m-20 -mt-0 p-0;
    }
    svg {
      width: 200%;
      height: 110%;
      display: none;

      @screen xl {
        display: initial;
        width: 140%;
        height: 120%;
        margin-top: -15%;
      }
    }
  }
  &__content {
    @apply z-10 text-white;
  }
}

.backgrounded-text:nth-of-type(n + 1) .backgrounded-text__bg {
  transform: skew(-5deg, -2deg);
  @screen xl {
    transform: none;
  }
}
.backgrounded-text:nth-of-type(n + 2) .backgrounded-text__bg {
  transform: skew(2deg, 5deg);
  @screen xl {
    transform: none;
  }
}
.backgrounded-text:nth-of-type(n + 3) .backgrounded-text__bg {
  transform: skew(1deg, -2deg);
  @screen xl {
    transform: none;
  }
}
.backgrounded-text:nth-of-type(n + 4) .backgrounded-text__bg {
  transform: skew(-3deg, 2deg);
  @screen xl {
    transform: none;
  }
}
</style>
